前言

LeetCode上一道不算难的题目,但是一开始做的时候,执行时间很不理想,通过多次修改代码,总算是改到比较满意的地步。原题目如下:

一个网站域名,如"discuss.leetcode.com",包含了多个子域名。作为顶级域名,常用的有"com",下一级则有"leetcode.com",最低的一级为"discuss.leetcode.com"。当我们访问域名"discuss.leetcode.com"时,也同时访问了其父域名"leetcode.com"以及顶级域名 "com"。

给定一个带访问次数和域名的组合,要求分别计算每个域名被访问的次数。其格式为访问次数+空格+地址,例如:"9001 discuss.leetcode.com"。

接下来会给出一组访问次数和域名组合的列表cpdomains 。要求解析出所有域名的访问次数,输出格式和输入格式相同,不限定先后顺序。

示例 1:
输入: 
["9001 discuss.leetcode.com"]
输出: 
["9001 discuss.leetcode.com", "9001 leetcode.com", "9001 com"]
说明: 
例子中仅包含一个网站域名:"discuss.leetcode.com"。按照前文假设,子域名"leetcode.com"和"com"都会被访问,所以它们都被访问了9001次。

示例 2:
输入: 
["900 google.mail.com", "50 yahoo.com", "1 intel.mail.com", "5 wiki.org"]
输出: 
["901 mail.com","50 yahoo.com","900 google.mail.com","5 wiki.org","5 org","1 intel.mail.com","951 com"]
说明: 
按照假设,会访问"google.mail.com" 900次,"yahoo.com" 50次,"intel.mail.com" 1次,"wiki.org" 5次。
而对于父域名,会访问"mail.com" 900+1 = 901次,"com" 900 + 50 + 1 = 951次,和 "org" 5 次。

注意事项:

  • cpdomains 的长度小于 100。
  • 每个域名的长度小于100。
  • 每个域名地址包含一个或两个"."符号。
  • 输入中任意一个域名的访问次数都小于10000。

解题思路

只要利用HashMap的key不会重复的特性和对String进行分割就可以快速完成这道题

实现代码

第一版

这个版本的代码执行所用测试用例所用时间达到了94ms(由于leetcode服务器的负荷情况,不同时间段执行的所用时间可能会存在一定差异),简直是慢到难以忍受的地步

    public List<String> subdomainVisits(String[] cpdomains) {
        List<String> list=new ArrayList<>();
        if(cpdomains!=null){
            Map<String,Integer> map=new HashMap<>();
            for(String cpdomain:cpdomains){
                String[] strs=cpdomain.split(" ");
                int times=Integer.valueOf(strs[0]);//访问次数
                String tmp=strs[1];//域名
                while(tmp.indexOf(".")!=-1){//域名中不存在点号.就结束
                    if(map.containsKey(tmp)){//判断是否存在这个域名的记录,有则累加,否则记录下来
                        map.put(tmp,map.get(tmp)+times);
                    }else{
                        map.put(tmp,times);
                    }
                    //切割域名,转换为更高一级的域名
                    tmp=tmp.substring(tmp.indexOf(".")+1);
                }
                //把最顶级域名的方法次数记录下来
                if(map.containsKey(tmp)){
                    map.put(tmp,map.get(tmp)+times);
                }else{
                    map.put(tmp,times);
                }
            }
            map.forEach((k,v)->{//使用函数式编程接口BiConsumer把map转为结果list
                list.add(v+" "+k);
            });
        }
        return list;
    }

第二版

通过优化后,执行时间变成了22ms,这么大的优化只是简单的替换了使用的API,其中优化点如下:

  1. 使用Map的getOrDefault方法代替传统的先使用containsKey方法判断是否存在来决定是否执行累加逻辑。这样可以减少Map的遍历次数。
  2. 不使用函数式编程接口,改为使用迭代器遍历Map中的元素
    public List<String> subdomainVisits(String[] cpdomains) {
        List<String> list=new ArrayList<>();
        if(cpdomains!=null){
            Map<String,Integer> map=new HashMap<>();
            for(String cpdomain:cpdomains){
                int times=Integer.valueOf(cpdomain.substring(0,cpdomain.indexOf(" ")));
                String domain=cpdomain.substring(cpdomain.indexOf(" ")+1);
                while(domain.indexOf(".")!=-1){
                    //减少判断是否存在的那次遍历
                    map.put(domain,map.getOrDefault(domain,0)+times);
                    domain=domain.substring(domain.indexOf(".")+1);
                }
                map.put(domain,map.getOrDefault(domain,0)+times);
            }
            //使用迭代器遍历Map的元素
            Iterator<Map.Entry<String, Integer>> it=map.entrySet().iterator();
            while(it.hasNext()){
                Map.Entry<String,Integer> entry=it.next();
                list.add(entry.getValue() + " " + entry.getKey());
            }
        }
        return list;
    }

Null
137 声望31 粉丝

免费的东西是最贵的,好走的只是下坡路


下一篇 »
896-单调数列